<?php
/**
 Class Definition for tutorKarma by Mokanova Inc.
 Last Edited: 2014-03-23 - Tim Hayward
**/
class tutorKarma {


  //mysqli database connection link
  private $db;

  function __construct() {

    include(dirname(__FILE__).'/tutorKarma.inc.php');
    $this->db = new mysqli($tutorKarma_config['db']['host'], $tutorKarma_config['db']['username'], $tutorKarma_config['db']['password'], $tutorKarma_config['db']['database']);
    if ($this->db->connect_errno) {
      echo "Failed to connect to MySQL: (" . $this->db->connect_errno . ") " . $this->db->connect_error;
    }
  }

  function __destruct() {
    $this->db->close();
  }

  /**
   * Insert or update progress for a student and course
   **/
  function progressUpdate100($uid,$aid,$cid,$prog,$scor) {
    $db = $this->db;
    $database_table_progress="TK_".$cid."_progress";
    $query = "SELECT * FROM $database_table_progress WHERE student_id='$uid' AND activity_id='$aid'" ;
    $result = mysqli_query($db, $query);
    $number_of_records = mysqli_num_rows($result);

    if ($number_of_records == 0) {
      $record_status="progress_undefined";// no record found for progress for this student
      $insert_req = "INSERT INTO $database_table_progress (student_id, activity_id, progress_percent) VALUES ('$uid', '$aid', '$prog')";//no score entered
      //print $insert_req;
      $req = mysqli_query($db, $insert_req) or die('Erreur SQL !<br>'.$insert_req.'<br>'.mysqli_error());
      $lastid = mysqli_insert_id($db);
      $status_done= "Progress recorded successfully. Progress ID is #: ".$lastid;
      //print $status_done;
      $record_status="progress_inserted";
    }
    else {
      // record found, update progress ONLY if progress is not 100 already.
      while ($row = mysqli_fetch_assoc($result)) {
        $Rec .= "progressPT=".$row['progress_percent']."&";
        $Rec .= "scorePT=".$row['score_percent']."&";
        $Rec .= "dateLM=".$row['date_lm'];
      }

      if ($Rec['progressPT'] != 100){
        $update_query = "UPDATE ".$database_table_progress." SET progress_percent='".$prog."' WHERE activity_id='".$aid."' AND student_id='".$uid."'";
        $update_req = mysqli_query($db, $update_query) or die('Erreur SQL !<br>'.$update_query.'<br>'.mysqli_error());

        $record_status="progress_updated";
      }
      else {// no update performed
        $record_status="progress_not_updated";
      }
    }

    return $record_status; // 4 outcomes: progress_undefined, progress_inserted, progress_updated, progress_not_updated
  }

  /**
   * Get progress for a user, activity and course code
  **/
  function getProgress($uid, $aid, $cid) {
    $db = $this->db;
    $database_table_progress="TK_".$cid."_progress";
    $query = "SELECT * FROM $database_table_progress WHERE student_id='$uid' AND activity_id='$aid'" ;
    $result = mysqli_query($db, $query);
    if(!$result) {
      if(function_exists('drupal_set_message')) {
        drupal_set_message('Mysql error: '.mysqli_error($db), 'error');
        return array();
      }
    }
    return mysqli_fetch_assoc($result);
  }
}

