<?php 

/*** moodle security */
require_once('../../../../../config.php');
// Requires a login.
require_login();
global $USER;
$mooodUserid=$USER->idnumber;

$firstName=$mooodUserid=$USER->firstname;
$lastName=$mooodUserid=$USER->lastname;

//print $lastName;

/* retrieve FLEX variables */
$fUID=(int) $_POST['student_id'];
$fAID=$_POST['activity_id'];
$fCID=$_POST['course_code'];
$fALLOW=1;

/* hardocoded for tests 

$fUID=20002;
$fAID="a";
$fCID="AGLPM1";
$fALLOW="allowed";

*/

//initialization process using data from postINC
$studentID=$fUID;
$activityID=$fAID;
$courseCODE=$fCID;
$allowedstudent=$fALLOW;

//echo "activityID:".$activityID;



require('postINC.php');




// Name comes from Drupal sesison variables as provided by postINC
$student_name=$firstName." ".$lastName;


//SYNC call to update points earned for this student and this course (all units and activities) 
$Returned_Points = update_points_earned ($fUID,$fCID,$fAID,$fALLOW);
//print ("Returned_Points : ".$Returned_Points."<br>"); 

//calls function that calculate unit status and updates certificate      
$Returned_Certificate = update_certificate ($fUID,$fCID,$fALLOW);
//print ("Returned_Certificate : ".$Returned_Certificate."<br>"); 

//ADD CONDITION TO TEST ALL WENT WELL????

If (strstr($Returned_Certificate,'UNIT')==FALSE)
{// some problem occurred stop here
echo "some problem occurred in the update certifcate step: ".$Returned_Certificate;
print ($Return); // sending to Flex content
exit();
}

else{

$database_table="TK_course";
$database_table2="TK_".$fCID."_certificateTK";
           
//*******   ***   ***   ***   ***   ***   ***   ***    */
// recording metadata to display on this certificate
//*******   ***   ***   ***   ***   ***   ***   ***    */


$QueryMeta = "SELECT `course_provider`, `course_code_certificate`,`course_title`,`course_time_hour` FROM $database_table WHERE `course_code`='$fCID'";
//echo $QueryMeta;
$ResultMeta = mysqli_query($lkid , $QueryMeta); 
if($recordMeta= mysqli_fetch_object ($ResultMeta )){
$coursePMICode=$recordMeta->course_code_certificate;
$courseTitle=$recordMeta->course_title;
$courseDuration=$recordMeta->course_time_hour;
$courseProvider=$recordMeta->course_provider;
}

//*******   ***   ***   ***   ***   ***   ***   ***    */
// recording certificate data for this student 
//*******   ***   ***   ***   ***   ***   ***   ***    */


$QueryCD = "SELECT `credits_earned`,`mention_excel`,`date_last_modified`,`certificate_number`\n"
    . "FROM $database_table2\n"
    . "WHERE `student_id`='$fUID' ";

$ResultCD = mysqli_query($lkid , $QueryCD); 

// recording certificate data to display on this certificate
if($recordCD= mysqli_fetch_object ($ResultCD )){
$cert_earned_pdu=$recordCD->credits_earned;
$mention_excel=$recordCD->mention_excel;
$cert_unique_id=$recordCD->certificate_number;
$cert_date_lm=$recordCD->date_last_modified;
}

// building an xml array
$Return = "<identities>"; // XML string starts here

$Return .= "<identity><student_id>".$fUID."</student_id><course_code>". 
            $courseCODE."</course_code><course_provider>". 
              $courseProvider."</course_provider><allowed>". 
            $allowedstudent."</allowed><course_title>".
            $courseTitle."</course_title><course_pmi_code>".
            $coursePMICode."</course_pmi_code><course_total_duration>".
             $courseDuration."</course_total_duration><student_name>".
               $student_name."</student_name><cert_earned_pdu>".
               $cert_earned_pdu."</cert_earned_pdu><mention_excel>".
                 $mention_excel."</mention_excel><cert_date_lm>".
                $cert_date_lm."</cert_date_lm><cert_unique_id>".
                $cert_unique_id."</cert_unique_id>";
                        
            //this is it
$Return .= "</identity></identities>";     



            
print ($Return); // sending to Flex content
mysqli_close($lkid);
}

?>